diff --git a/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java b/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java
index 3260af6e7b7274ee05247d99889db8ed31d53ef0..c9b64fcaf70a1517fc1278e588fbd18e672f7c0a 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java
@@ -121,10 +121,10 @@ public abstract class DirBasedAuthentication
         "E=$attr.mail, CN=$attr.cn, O=$dn.o, C=$dn.c";
 
     /* Vector of extendedPluginInfo strings */
-    protected static Vector mExtendedPluginInfo = null;
+    protected static Vector<String> mExtendedPluginInfo = null;
 
     static {
-        mExtendedPluginInfo = new Vector();
+        mExtendedPluginInfo = new Vector<String>();
         mExtendedPluginInfo.add(PROP_DNPATTERN + ";string;Template for cert" +
             " Subject Name. ($dn.xxx - get value from user's LDAP " +
             "DN.  $attr.yyy - get value from LDAP attributes in " +
@@ -563,8 +563,9 @@ public abstract class DirBasedAuthentication
 
         if (values == null) return;
 
-        Vector v = new Vector();
-        Enumeration e = values.getStringValues();
+        Vector<String> v = new Vector<String>();
+        @SuppressWarnings("unchecked")
+		Enumeration<String> e = values.getStringValues();
 
         while (e.hasMoreElements()) {
             v.addElement(e.nextElement());
@@ -583,8 +584,9 @@ public abstract class DirBasedAuthentication
 
         if (values == null) return;
 
-        Vector v = new Vector();
-        Enumeration e = values.getByteValues();
+        Vector<byte[]> v = new Vector<byte[]>();
+        @SuppressWarnings("unchecked")
+		Enumeration<byte[]> e = values.getByteValues();
 
         while (e.hasMoreElements()) {
             v.addElement(e.nextElement());
diff --git a/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java b/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java
index 3092d00a1055e8a02df1e6e55b2bd720d4886717..e73a112ce811a1b47d01d2ee6619eb937bacbc23 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java
@@ -331,7 +331,7 @@ public class SSLclientCertAuthentication implements IAuthManager,
     /**
      * Retrieves a list of names of the value parameter.
      */
-    public Enumeration getValueNames() {
+    public Enumeration<String> getValueNames() {
         return null;
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java b/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
index cfa6ff577cbe382fea9fb0fdea172f6ec557805e..0468e13fc822a5150a96cdd41c1a2ccf82e0eb6c 100644
--- a/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
+++ b/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
@@ -103,12 +103,12 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
     private final static String PROP_INCLUDE_NEXT_UPDATE =
         "includeNextUpdate";
 
-    protected Hashtable mReqCounts = new Hashtable();
+    protected Hashtable<String, Long> mReqCounts = new Hashtable<String, Long>();
     protected boolean mNotFoundGood = true;
     protected boolean mUseCache = true;
     protected boolean mByName = true;
     protected boolean mIncludeNextUpdate = false;
-    protected Hashtable mCacheCRLIssuingPoints = new Hashtable();
+    protected Hashtable<String, CRLIPContainer> mCacheCRLIssuingPoints = new Hashtable<String, CRLIPContainer>();
     private IOCSPAuthority mOCSPAuthority = null;
     private IConfigStore mConfig = null;
     private String mId = null;
@@ -124,7 +124,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
     }
 
     public String[] getExtendedPluginInfo(Locale locale) { 
-        Vector v = new Vector(); 
+        Vector<String> v = new Vector<String>(); 
 
         v.addElement(PROP_NOT_FOUND_GOOD + ";boolean; " + CMS.getUserMessage(locale, "CMS_OCSP_DEFSTORE_PROP_NOT_FOUND_GOOD"));
         v.addElement(PROP_BY_NAME + ";boolean; " + CMS.getUserMessage(locale, "CMS_OCSP_DEFSTORE_PROP_BY_NAME"));
@@ -226,7 +226,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
      * new one is totally committed.
      */
     public void deleteOldCRLs() throws EBaseException {
-        Enumeration recs = searchCRLIssuingPointRecord(
+        Enumeration<ICRLIssuingPointRecord> recs = searchCRLIssuingPointRecord(
                 "objectclass=" +
                 CMS.getCRLIssuingPointRecordName(),
                 100);
@@ -234,7 +234,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         ICRLIssuingPointRecord theRec = null;
 
         while (recs.hasMoreElements()) {
-            ICRLIssuingPointRecord rec = (ICRLIssuingPointRecord)
+            ICRLIssuingPointRecord rec = 
                 recs.nextElement();
 
             deleteOldCRLsInCA(rec.getId());
@@ -254,15 +254,14 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                 return; // nothing to do
             String thisUpdate = Long.toString(
                     cp.getThisUpdate().getTime());
-            Enumeration e = searchRepository(
+            Enumeration<IRepositoryRecord> e = searchRepository(
                     caName,
                     "(!" + IRepositoryRecord.ATTR_SERIALNO + "=" +
                     thisUpdate + ")");
 
             while (e != null && e.hasMoreElements()) {
-                IRepositoryRecord r = (IRepositoryRecord)
-                    e.nextElement();
-                Enumeration recs = 
+                IRepositoryRecord r = e.nextElement();
+                Enumeration<ICertRecord> recs = 
                     searchCertRecord(caName,
                         r.getSerialNumber().toString(),
                         ICertRecord.ATTR_ID + "=*");
@@ -276,7 +275,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                     getBaseDN();
 
                 while (recs != null && recs.hasMoreElements()) {
-                    ICertRecord rec = (ICertRecord) recs.nextElement();
+                    ICertRecord rec =  recs.nextElement();
                     String cert_dn = "cn=" + 
                         rec.getSerialNumber().toString() + "," + rep_dn;
 
@@ -338,7 +337,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
 
             // (3) look into database to check the
             //     certificate's status
-            Vector singleResponses = new Vector();
+            Vector<SingleResponse> singleResponses = new Vector<SingleResponse>();
             if (statsSub != null) {
               statsSub.startTiming("lookup");
             }
@@ -439,7 +438,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                 mCacheCRLIssuingPoints.get(new String(keyhsh));
 
             if (matched == null) {
-                Enumeration recs = searchCRLIssuingPointRecord(
+                Enumeration<ICRLIssuingPointRecord> recs = searchCRLIssuingPointRecord(
                         "objectclass=" +
                         CMS.getCRLIssuingPointRecordName(),
                         100);
@@ -523,7 +522,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                     // if crl is not available, we can try crl cache
                     if (theRec != null) {
                         CMS.debug("DefStore: evaluating crl cache");
-                        Hashtable cache = theRec.getCRLCacheNoClone();
+                        Hashtable<BigInteger, RevokedCertificate> cache = theRec.getCRLCacheNoClone();
                         if (cache != null) {
                              RevokedCertificate rc = (RevokedCertificate)
                                   cache.get(new BigInteger(serialNo.toString()));
@@ -581,7 +580,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         return mDBService.getBaseDN();
     }
 
-    public Enumeration searchAllCRLIssuingPointRecord(int maxSize)
+    public Enumeration<ICRLIssuingPointRecord > searchAllCRLIssuingPointRecord(int maxSize)
         throws EBaseException {
         return searchCRLIssuingPointRecord(
                 "objectclass=" +
@@ -589,11 +588,11 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                 maxSize);
     }
 
-    public Enumeration searchCRLIssuingPointRecord(String filter,
+    public Enumeration<ICRLIssuingPointRecord> searchCRLIssuingPointRecord(String filter,
         int maxSize)
         throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration e = null;
+        Enumeration<ICRLIssuingPointRecord> e = null;
 
         try {
             e = s.search(getBaseDN(), filter, maxSize);
@@ -683,10 +682,10 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         }
     }
 
-    public Enumeration searchRepository(String name, String filter)
+    public Enumeration<IRepositoryRecord> searchRepository(String name, String filter)
         throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration e = null;
+        Enumeration<IRepositoryRecord> e = null;
 
         try {
             e = s.search("cn=" + transformDN(name) + "," + getBaseDN(),
@@ -732,10 +731,10 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         }
     }
 
-    public Enumeration searchCertRecord(String name, String thisUpdate,
+    public Enumeration<ICertRecord> searchCertRecord(String name, String thisUpdate,
         String filter) throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration e = null;
+        Enumeration<ICertRecord> e = null;
 
         try {
             e = s.search("ou=" + thisUpdate + ",cn=" +
@@ -806,7 +805,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
 
     public void setConfigParameters(NameValuePairs pairs) 
         throws EBaseException { 
-        Enumeration k = pairs.getNames();
+        Enumeration<String> k = pairs.getNames();
 
         while (k.hasMoreElements()) {
             String key = (String) k.nextElement();
@@ -932,10 +931,10 @@ class CRLIPContainer {
 }
 
 class DefStoreCRLUpdater extends Thread {
-    private Hashtable mCache = null;
+    private Hashtable<String, CRLIPContainer> mCache = null;
     private int mSec = 0;
 
-    public DefStoreCRLUpdater(Hashtable cache, int sec) {
+    public DefStoreCRLUpdater(Hashtable<String, CRLIPContainer> cache, int sec) {
         mCache = cache;
         mSec = sec;
     }
diff --git a/pki/base/common/src/com/netscape/cms/policy/constraints/UniqueSubjectNameConstraints.java b/pki/base/common/src/com/netscape/cms/policy/constraints/UniqueSubjectNameConstraints.java
index 4e7cefe7ec1d7494b495055b2f7017d8c4543af1..2cff24d378111304ef4d50090246bf515f20a5cf 100644
--- a/pki/base/common/src/com/netscape/cms/policy/constraints/UniqueSubjectNameConstraints.java
+++ b/pki/base/common/src/com/netscape/cms/policy/constraints/UniqueSubjectNameConstraints.java
@@ -184,11 +184,11 @@ public class UniqueSubjectNameConstraints extends APolicyRule
                 String filter = "x509Cert.subject=" + certSubjectName;
                 // subject name is indexed, so we only use subject name
                 // in the filter
-                Enumeration matched = 
+                Enumeration<ICertRecord> matched = 
                     mCA.getCertificateRepository().findCertRecords(filter);
 
                 while (matched.hasMoreElements()) {
-                    ICertRecord rec = (ICertRecord) matched.nextElement();
+                    ICertRecord rec =  matched.nextElement();
                     String status = rec.getStatus();
 
                     if (status.equals(ICertRecord.STATUS_REVOKED) || status.equals(ICertRecord.STATUS_EXPIRED) || status.equals(ICertRecord.STATUS_REVOKED_EXPIRED)) {
@@ -250,7 +250,7 @@ public class UniqueSubjectNameConstraints extends APolicyRule
         } else {
             try {
                 ext = (KeyUsageExtension) extensions.get(
-                            KeyUsageExtension.NAME);
+                            KeyUsageExtension.class.getSimpleName());
             } catch (IOException e) {
                 // extension isn't there.
             }
@@ -285,8 +285,8 @@ public class UniqueSubjectNameConstraints extends APolicyRule
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getInstanceParams() {
-        Vector confParams = new Vector();
+    public Vector<String> getInstanceParams() {
+        Vector<String> confParams = new Vector<String>();
 
         confParams.addElement(PROP_PRE_AGENT_APPROVAL_CHECKING +
             "=" + mPreAgentApprovalChecking);
@@ -300,8 +300,8 @@ public class UniqueSubjectNameConstraints extends APolicyRule
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getDefaultParams() { 
-        Vector defParams = new Vector();
+    public Vector<String> getDefaultParams() { 
+        Vector<String> defParams = new Vector<String>();
 
         defParams.addElement(PROP_PRE_AGENT_APPROVAL_CHECKING + "=");
         defParams.addElement(PROP_KEY_USAGE_EXTENSION_CHECKING + "=");
diff --git a/pki/base/common/src/com/netscape/cms/policy/extensions/AuthInfoAccessExt.java b/pki/base/common/src/com/netscape/cms/policy/extensions/AuthInfoAccessExt.java
index b641d91ed7e3b746a67b1c7f9fbd397daf576ecb..4f8aaa293ac5389348fdc3441f5f78810bb71fd1 100644
--- a/pki/base/common/src/com/netscape/cms/policy/extensions/AuthInfoAccessExt.java
+++ b/pki/base/common/src/com/netscape/cms/policy/extensions/AuthInfoAccessExt.java
@@ -19,6 +19,7 @@ package com.netscape.cms.policy.extensions;
 
 
 import java.io.IOException;
+import java.io.Serializable;
 import java.security.cert.CertificateException;
 import java.util.Enumeration;
 import java.util.Locale;
@@ -105,7 +106,7 @@ public class AuthInfoAccessExt extends APolicyRule implements
     }
 
     public String[] getExtendedPluginInfo(Locale locale) {
-        Vector v = new Vector();
+        Vector<String> v = new Vector<String>();
 
         v.addElement(PROP_CRITICAL +
             ";boolean;RFC 2459 recommendation: This extension MUST be non-critical.");
@@ -144,8 +145,8 @@ public class AuthInfoAccessExt extends APolicyRule implements
     /**
      * Returns a sequence of access descriptions.
      */
-    private Enumeration getAccessDescriptions() throws EBaseException {
-        Vector ads = new Vector();
+    private Enumeration<Vector<Serializable>> getAccessDescriptions() throws EBaseException {
+        Vector<Vector<Serializable>> ads = new Vector<Vector<Serializable>>();
 
         //
         // read until there is *NO* ad<NUM>_method
@@ -195,7 +196,7 @@ public class AuthInfoAccessExt extends APolicyRule implements
             if (location == null)
                 break;
             GeneralName gn = CMS.form_GeneralName(location_type, location);
-            Vector e = new Vector(); 
+            Vector<Serializable> e = new Vector<Serializable>(); 
 
             e.addElement(methodOID);
             e.addElement(gn);
@@ -240,7 +241,7 @@ public class AuthInfoAccessExt extends APolicyRule implements
                     certInfo.get(X509CertInfo.EXTENSIONS);
 
                 // add access descriptions
-                Enumeration e = getAccessDescriptions();
+                Enumeration<Vector<Serializable>> e = getAccessDescriptions();
 
                 if (!e.hasMoreElements()) {
                     return res;
@@ -255,8 +256,8 @@ public class AuthInfoAccessExt extends APolicyRule implements
                 } else {
                     // check to see if AIA is already exist
                     try {
-                        extensions.delete(AuthInfoAccessExtension.NAME);
-                        log(ILogger.LL_WARN, "Previous extension deleted: " + AuthInfoAccessExtension.NAME);
+                        extensions.delete(AuthInfoAccessExtension.class.getSimpleName());
+                        log(ILogger.LL_WARN, "Previous extension deleted: " + AuthInfoAccessExtension.class.getSimpleName());
                     } catch (IOException ex) {
                     }
                 }
@@ -267,13 +268,13 @@ public class AuthInfoAccessExt extends APolicyRule implements
                             PROP_CRITICAL, false));
 
                 while (e.hasMoreElements()) {
-                    Vector ad = (Vector) e.nextElement();
+                    Vector<Serializable> ad =  e.nextElement();
                     ObjectIdentifier oid = (ObjectIdentifier) ad.elementAt(0);
                     GeneralName gn = (GeneralName) ad.elementAt(1);
 
                     aiaExt.addAccessDescription(oid, gn);
                 }
-                extensions.set(AuthInfoAccessExtension.NAME, aiaExt);
+                extensions.set(AuthInfoAccessExtension.class.getSimpleName(), aiaExt);
 
             } catch (IOException e) {
                 log(ILogger.LL_FAILURE, CMS.getLogMessage("POLICY_UNEXPECTED_POLICY_ERROR", NAME, e.getMessage()));
@@ -301,8 +302,8 @@ public class AuthInfoAccessExt extends APolicyRule implements
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getInstanceParams() { 
-        Vector params = new Vector();
+    public Vector<String> getInstanceParams() { 
+        Vector<String> params = new Vector<String>();
 
         try {
             params.addElement(PROP_CRITICAL + "=" + 
@@ -363,8 +364,8 @@ public class AuthInfoAccessExt extends APolicyRule implements
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getDefaultParams() { 
-        Vector defParams = new Vector();
+    public Vector<String> getDefaultParams() { 
+        Vector<String> defParams = new Vector<String>();
 
         defParams.addElement(PROP_CRITICAL + "=false");
         defParams.addElement(PROP_NUM_ADS + "=" + MAX_AD);
diff --git a/pki/base/common/src/com/netscape/cms/policy/extensions/AuthorityKeyIdentifierExt.java b/pki/base/common/src/com/netscape/cms/policy/extensions/AuthorityKeyIdentifierExt.java
index 612d24925ef968fac2bb40d96426c66a0710656a..7ec05fec4624f344880792d49827569f3b19c7bf 100644
--- a/pki/base/common/src/com/netscape/cms/policy/extensions/AuthorityKeyIdentifierExt.java
+++ b/pki/base/common/src/com/netscape/cms/policy/extensions/AuthorityKeyIdentifierExt.java
@@ -81,10 +81,10 @@ public class AuthorityKeyIdentifierExt extends APolicyRule
     protected AuthorityKeyIdentifierExtension mTheExtension = null;
 
     // instance params for console
-    protected Vector mInstanceParams = new Vector();
+    protected Vector<String> mInstanceParams = new Vector<String>();
 
     // default params for console.
-    protected static Vector mDefaultParams = new Vector();
+    protected static Vector<String> mDefaultParams = new Vector<String>();
     static {
         // form static default params.
         mDefaultParams.addElement(PROP_CRITICAL + "=" + DEF_CRITICAL);
@@ -228,7 +228,7 @@ public class AuthorityKeyIdentifierExt extends APolicyRule
             try {
                 if (extensions != null) {
                     authorityKeyIdExt = (AuthorityKeyIdentifierExtension)
-                            extensions.get(AuthorityKeyIdentifierExtension.NAME);
+                            extensions.get(AuthorityKeyIdentifierExtension.class.getSimpleName());
                 }
             } catch (IOException e) {
                 // extension isn't there. 
@@ -244,7 +244,7 @@ public class AuthorityKeyIdentifierExt extends APolicyRule
                     CMS.debug(
                         "AuthorityKeyIdentifierKeyExt: request id from user " + req.getRequestId() +
                         " had authority key identifier - deleted");
-                    extensions.delete(AuthorityKeyIdentifierExtension.NAME);
+                    extensions.delete(AuthorityKeyIdentifierExtension.class.getSimpleName());
                 }
             }
 
@@ -261,7 +261,7 @@ public class AuthorityKeyIdentifierExt extends APolicyRule
                 certInfo.set(X509CertInfo.EXTENSIONS, extensions);
             }
             extensions.set(
-                AuthorityKeyIdentifierExtension.NAME, mTheExtension);
+                AuthorityKeyIdentifierExtension.class.getSimpleName(), mTheExtension);
             CMS.debug(
                 "AuthorityKeyIdentifierKeyExt: added authority key id ext to request " + req.getRequestId());
             return PolicyResult.ACCEPTED;
@@ -362,7 +362,7 @@ public class AuthorityKeyIdentifierExt extends APolicyRule
 
         try {
             subjKeyIdExt = (SubjectKeyIdentifierExtension)
-                    exts.get(SubjectKeyIdentifierExtension.NAME);
+                    exts.get(SubjectKeyIdentifierExtension.class.getSimpleName());
         } catch (IOException e) {
             // extension isn't there.
             CMS.debug(
@@ -391,7 +391,7 @@ public class AuthorityKeyIdentifierExt extends APolicyRule
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getInstanceParams() { 
+    public Vector<String> getInstanceParams() { 
         return mInstanceParams;
     }
 
@@ -400,7 +400,7 @@ public class AuthorityKeyIdentifierExt extends APolicyRule
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getDefaultParams() { 
+    public Vector<String> getDefaultParams() { 
         return mDefaultParams;
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/policy/extensions/BasicConstraintsExt.java b/pki/base/common/src/com/netscape/cms/policy/extensions/BasicConstraintsExt.java
index 4c2eb46439feaba0bd94f46c43cb0912c6c2e307..1636902d2331fb815f8e0a40cd372c4aeda667d5 100644
--- a/pki/base/common/src/com/netscape/cms/policy/extensions/BasicConstraintsExt.java
+++ b/pki/base/common/src/com/netscape/cms/policy/extensions/BasicConstraintsExt.java
@@ -258,7 +258,7 @@ public class BasicConstraintsExt extends APolicyRule
                     certInfo.get(X509CertInfo.EXTENSIONS);
             if (extensions != null) {
                 basicExt = (BasicConstraintsExtension)
-                        extensions.get(BasicConstraintsExtension.NAME);
+                        extensions.get(BasicConstraintsExtension.class.getSimpleName());
             }
         } catch (IOException e) {
             // no extensions or basic constraints extension.
@@ -283,7 +283,7 @@ public class BasicConstraintsExt extends APolicyRule
             }
             if (basicExt != null) {
                 try {
-                    extensions.delete(BasicConstraintsExtension.NAME);
+                    extensions.delete(BasicConstraintsExtension.class.getSimpleName());
                 } catch (IOException e) {
                 }
             }
@@ -302,7 +302,7 @@ public class BasicConstraintsExt extends APolicyRule
             }
  
             try {
-                extensions.set(BasicConstraintsExtension.NAME, critExt);
+                extensions.set(BasicConstraintsExtension.class.getSimpleName(), critExt);
             } catch (IOException e) {
             }
             CMS.debug(
@@ -378,8 +378,8 @@ public class BasicConstraintsExt extends APolicyRule
                             CMS.getUserMessage("CMS_POLICY_BASIC_CONSTRAINTS_ERROR", NAME), "");
                         return PolicyResult.REJECTED; // unrecoverable error.
                     }
-                    extensions.delete(BasicConstraintsExtension.NAME);
-                    extensions.set(BasicConstraintsExtension.NAME, critExt);
+                    extensions.delete(BasicConstraintsExtension.class.getSimpleName());
+                    extensions.set(BasicConstraintsExtension.class.getSimpleName(), critExt);
                 }
             } catch (IOException e) {
                 // not possible in these cases.
@@ -450,7 +450,7 @@ public class BasicConstraintsExt extends APolicyRule
             return PolicyResult.REJECTED; // unrecoverable error.
         }
         try {
-            extensions.set(BasicConstraintsExtension.NAME, newExt);
+            extensions.set(BasicConstraintsExtension.class.getSimpleName(), newExt);
         }catch (IOException e) {
             // doesn't happen.
         }
@@ -465,8 +465,8 @@ public class BasicConstraintsExt extends APolicyRule
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getInstanceParams() { 
-        Vector params = new Vector();
+    public Vector<String> getInstanceParams() { 
+        Vector<String> params = new Vector<String>();
 
         // Because of one of the UI bugs 385273, we should leave the empty space
         // as is. Do not convert the space to some definite numbers.
@@ -481,8 +481,8 @@ public class BasicConstraintsExt extends APolicyRule
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getDefaultParams() { 
-        Vector defParams = new Vector();
+    public Vector<String> getDefaultParams() { 
+        Vector<String> defParams = new Vector<String>();
 
         defParams.addElement(PROP_IS_CRITICAL + "=true");
         defParams.addElement(PROP_MAXPATHLEN + "=");
diff --git a/pki/base/common/src/com/netscape/cms/policy/extensions/CRLDistributionPointsExt.java b/pki/base/common/src/com/netscape/cms/policy/extensions/CRLDistributionPointsExt.java
index cec8051b8a22dd4204365e4f6dc44863327dde7a..05d4a28e170bd6a76aa2fc5dd683c7c6b69a290e 100644
--- a/pki/base/common/src/com/netscape/cms/policy/extensions/CRLDistributionPointsExt.java
+++ b/pki/base/common/src/com/netscape/cms/policy/extensions/CRLDistributionPointsExt.java
@@ -76,14 +76,14 @@ class NameType {
         stringRep = s;
     }
 
-    private static Hashtable map = new Hashtable();
+    private static Hashtable<String, NameType> map = new Hashtable<String, NameType>();
 
     /**
      * Looks up a NameType from its string representation.  Returns null
      * if no matching NameType was found.
      */
     public static NameType fromString(String s) {
-        return (NameType) map.get(s);
+        return map.get(s);
     }
 
     public String toString() {
@@ -147,9 +147,9 @@ public class CRLDistributionPointsExt extends APolicyRule
     // PKIX specifies the that the extension SHOULD NOT be critical
     public static final boolean DEFAULT_CRITICALITY = false;
 
-    private Vector defaultParams = new Vector();
+    private Vector<String> defaultParams = new Vector<String>();
 
-    private Vector mParams = new Vector();
+    private Vector<String> mParams = new Vector<String>();
     private String mExtParams[] = null;
     private CRLDistributionPointsExtension mCrldpExt = null;
 
@@ -168,7 +168,7 @@ public class CRLDistributionPointsExt extends APolicyRule
     }
 
     private void setExtendedPluginInfo() {
-        Vector v = new Vector();
+        Vector<String> v = new Vector<String>();
 
         // should replace MAX_POINTS with mNumPoints if bug 385118 is fixed
         for (int i = 0; i < MAX_POINTS; i++) {
@@ -218,7 +218,7 @@ public class CRLDistributionPointsExt extends APolicyRule
             netscape.security.x509.OIDMap.addAttribute(
                 CRLDistributionPointsExtension.class.getName(),
                 CRLDistributionPointsExtension.OID,
-                CRLDistributionPointsExtension.NAME);
+                CRLDistributionPointsExtension.class.getSimpleName());
         } catch (CertificateException e) {
             // ignore, just means it has already been added
         }
@@ -434,12 +434,12 @@ public class CRLDistributionPointsExt extends APolicyRule
             } else {
                 // remove any previously computed version of the extension
                 try {
-                    extensions.delete(CRLDistributionPointsExtension.NAME);
+                    extensions.delete(CRLDistributionPointsExtension.class.getSimpleName());
                 } catch (IOException e) {
                     // extension isn't there
                 }
             }
-            extensions.set(CRLDistributionPointsExtension.NAME, mCrldpExt);
+            extensions.set(CRLDistributionPointsExtension.class.getSimpleName(), mCrldpExt);
 
             return PolicyResult.ACCEPTED;
 
@@ -458,7 +458,7 @@ public class CRLDistributionPointsExt extends APolicyRule
     }
 
     // parameters must be entered in the config file
-    public Vector getDefaultParams() {
+    public Vector<String> getDefaultParams() {
         for (int i = DEFAULT_NUM_BLANK_POINTS; i < mNumPoints; i++) {
             defaultParams.addElement(PROP_POINT_NAME + i + "=");
             defaultParams.addElement(PROP_POINT_TYPE + i + "=");
@@ -474,7 +474,7 @@ public class CRLDistributionPointsExt extends APolicyRule
      *
      * @return nvPairs A Vector of name/value pairs.
      */
-    public Vector getInstanceParams() {
+    public Vector<String> getInstanceParams() {
         return mParams;
     }
 }
